package hu.bme.iit.ar.opencvexample;

import android.opengl.GLES10;

public class Material extends Resource{
  public static int ALPHA_BLEND_MODE_NONE = 0;
  public static int ALPHA_BLEND_MODE_BLEND = 1;
  public static int ALPHA_BLEND_MODE_ADD = 2;
  
  protected Texture texture = null;
  protected boolean lighting = false;
  protected int alphaBlendMode = ALPHA_BLEND_MODE_NONE;
  protected float color[] = new float[4];

  public Material(String name) {
    super(name);
    setColor(1,1,1,1);
  }

  public void setTexture(Texture texture) {
    this.texture = texture;
  }
  public Texture getTexture() {
    return this.texture;
  }
  public void setLighting(boolean on) {
    this.lighting = on;
  }
  public boolean getLighting() {
    return this.lighting;
  }
  public int getAlphaBlendMode() {
      return alphaBlendMode;
  }
  public void setAlhpaBlendMode(int mode){
      alphaBlendMode = mode;
  }
  public void setColor(float r, float g, float b, float a){ color[0] = r;color[1] = g;color[2] = b;color[3] = a;}
  
  public void load()
  {
  }

  public void destroy()
  {
  }

  public void set() {
    if (this.texture != null)
      this.texture.enable();
    else
      Texture.disable();
    if (alphaBlendMode != ALPHA_BLEND_MODE_NONE) {
      GLES10.glEnable(GLES10.GL_BLEND);
      if (alphaBlendMode == ALPHA_BLEND_MODE_ADD)
        GLES10.glBlendFunc(GLES10.GL_ONE, GLES10.GL_ONE);
      else
        GLES10.glBlendFunc(GLES10.GL_SRC_ALPHA, GLES10.GL_ONE_MINUS_SRC_ALPHA);
    } else {
      GLES10.glDisable(GLES10.GL_BLEND);
    }
    if (lighting){
      GLES10.glMaterialfv(GLES10.GL_FRONT_AND_BACK,GLES10.GL_AMBIENT,color,0);
      GLES10.glMaterialfv(GLES10.GL_FRONT_AND_BACK,GLES10.GL_DIFFUSE,color,0);
      GLES10.glEnable(GLES10.GL_LIGHTING);
    } else {
      GLES10.glColor4f(color[0],color[1],color[2],color[3]);
      GLES10.glDisable(GLES10.GL_LIGHTING);
    }
  }
    
}
