package hu.bme.iit.ar.opencvexample;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class Quad extends Mesh
{
  public Quad(String name){
    super(name);
    this.vertexcount = 6;
  }

  public void load(){
    float[] VCoords = { 
      -1.0F, -1.0F, 0.0F, 
      1.0F, -1.0F, 0.0F, 
      1.0F, 1.0F, 0.0F, 
      -1.0F, -1.0F, 0.0F, 
      1.0F, 1.0F, 0.0F, 
      -1.0F, 1.0F, 0.0F };

    float[] TCoords = { 
      0.0F, 1.0F, 
      1.0F, 1.0F, 
      1.0F, 0.0F, 
      0.0F, 1.0F, 
      1.0F, 0.0F, 
      0.0F, 0.0F };

    float[] NCoords = { 
      0.0F, 0.0F, 1.0F, 
      0.0F, 0.0F, 1.0F, 
      0.0F, 0.0F, 1.0F, 
      0.0F, 0.0F, 1.0F, 
      0.0F, 0.0F, 1.0F, 
      0.0F, 0.0F, 1.0F };

    ByteBuffer vbb = ByteBuffer.allocateDirect(VCoords.length * 4);
    vbb.order(ByteOrder.nativeOrder());
    this.VB = vbb.asFloatBuffer();
    this.VB.put(VCoords);
    this.VB.position(0);

    ByteBuffer nbb = ByteBuffer.allocateDirect(NCoords.length * 4);
    nbb.order(ByteOrder.nativeOrder());
    this.NB = nbb.asFloatBuffer();
    this.NB.put(NCoords);
    this.NB.position(0);

    ByteBuffer tbb = ByteBuffer.allocateDirect(TCoords.length * 4);
    tbb.order(ByteOrder.nativeOrder());
    this.TB = tbb.asFloatBuffer();
    this.TB.put(TCoords);
    this.TB.position(0);
  }  
}


